/* bubbletrail.js

Bubble trail
Written by Pintr Gbor
Feuerwehrgasse 1/2/9
Purbach am Neusiedlersee
A-7083, Austria
Tel: +43 681 20821067, +36 20 4331532
Email: pinter.gabor@gmx.at
Web: http://www.pic18.eu

Revisions:
  V1.0  2014-03-19  Created from an incomplete example of 
  		    http://incompl.com/ I found on http://codepen.io
  V1.1  2014-07-02  Works correctly in scrolled window



This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

http://www.gnu.org/copyleft/gpl.html

For commercial license, and for other professional
JavaScript and Java components please contact the author.





Usage:
  1. Extract the contents of the zip file into the same directory where your page is.
  2. Include this file from the head of your page.
  3. Define parameters or accept the defaults.

This script requires Internet Explorer 5+, Nescape Navigator 6+!,
or any version of Firefox, Opera, Chrome or Safari.



1. Extract the contents of the zip file into the same directory where your page is.


2. Include elesticbullets.js from the head of your page
Insert the following line into the head of your page:
  <script type="text/javascript" src="bubbletrail.js"></script>


3. Define parameters
You can accept the defaults or assign new values to these variables:

Max size of a bubble
  bubbletrail.size= 10;

Max position jitter
  bubbletrail.jitter= 20;

Define average z order position of bubbles
  bubbletrail.zindex= 5;
  
Max life of a bubble in milliseconds
  bubbletrail.life= 1000;


4. Change parameters after the page is loaded
You can change parameters after the page is loaded,
e.g. using user inputs from edit boxes,
but you have to call bubbletrail.create() to activate those changes.



Example: http://www.pic18.eu/en/www/bubbletrail/

*/



//------------------------------------------------------------------------------
// bubbletrail object
//------------------------------------------------------------------------------



// Create empty
var bubbletrail= {};



// Add public parameters with default values
bubbletrail.size= 10;
bubbletrail.jitter= 50;
bubbletrail.zindex= 5;
bubbletrail.life= 1000;



// Create after the page is loaded
window.onload= function() {
	window.addEventListener('mousemove', function(e) {
		// Animate one dot
		var animate= function(i) {
			var j= (1-i)*bubbletrail.jitter;
			var bubble= document.createElement('div');
			var size= Math.ceil(Math.random()*bubbletrail.size*i);
			var sizepx= size+'px';
			bubble.style.position= 'fixed';
			bubble.style.top=  e.clientY + 
				Math.round((Math.random()-0.5)*j - size/2) + 'px';
			bubble.style.left= e.clientX + 
				Math.round((Math.random()-0.5)*j - size/2) + 'px';
			bubble.style.width= sizepx;
			bubble.style.height= sizepx;
			bubble.style.background= 'hsla(' +
				Math.round(Math.random()*360) + ', ' +
				'100%, ' +
				'50%, ' +
				i + ')';
			bubble.style.borderRadius= sizepx;
			bubble.style.pointerEvents= 'none';
			bubble.style.zIndex= bubbletrail.zindex + 
				Math.round(5*(Math.random()-0.5));
			document.body.appendChild(bubble);
			window.setTimeout(function() {
				document.body.removeChild(bubble);
			}, Math.round(Math.random()*i*bubbletrail.life));
		};
		// Create a bunch of dots
		for (var i= 0.2; i <= 1.0; i+= 0.2) {
			animate(i);
		}
	});
};


